ClassLoader (jakarta-bcel 5.2 API)
Keywords: org.apache.bcel.util.ClassLoader class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.bcel.util
Class ClassLoader

    java.lang.Object
      java.lang.ClassLoader
          org.apache.bcel.util.ClassLoader

    public class ClassLoader

extends ClassLoader

Drop in replacement for the standard class loader of the JVM. You can use it in conjunction with the JavaWrapper to dynamically modify/create classes as they're requested.

This class loader recognizes special requests in a distinct format, i.e., when the name of the requested class contains with "$$BCEL$$" it calls the createClass() method with that name (everything bevor the $$BCEL$$ is considered to be the package name. You can subclass the class loader and override that method. "Normal" classes class can be modified by overriding the modifyClass() method which is called just before defineClass().

There may be a number of packages where you have to use the default class loader (which may also be faster). You can define the set of packages where to use the system class loader in the constructor. The default value contains "java.", "sun.", "javax."

Version:
  $Id: ClassLoader.java 386056 2006-03-15 11:31:56Z tcurdt $
See Also:
  `JavaWrapper`, `ClassPath`

Field Summary
`static String[]` | `DEFAULT_IGNORED_PACKAGES`

Constructor Summary
`ClassLoader()` Ignored packages are by default ( "java.", "sun.", "javax."), i.e.
`ClassLoader(ClassLoader deferTo)`
`ClassLoader(ClassLoader deferTo, String[] ignored_packages)`
`ClassLoader(String[] ignored_packages)`

Method Summary
`protected JavaClass` | `createClass(String class_name)` Override this method to create you own classes on the fly.
`protected Class` | `loadClass(String class_name, boolean resolve)`
`protected JavaClass` | `modifyClass(JavaClass clazz)` Override this method if you want to alter a class before it gets actually loaded.

Methods inherited from class java.lang.ClassLoader
`clearAssertionStatus, defineClass, defineClass, defineClass, defineClass, definePackage, findClass, findLibrary, findLoadedClass, findResource, findResources, findSystemClass, getPackage, getPackages, getParent, getResource, getResourceAsStream, getResources, getSystemClassLoader, getSystemResource, getSystemResourceAsStream, getSystemResources, loadClass, resolveClass, setClassAssertionStatus, setDefaultAssertionStatus, setPackageAssertionStatus, setSigners`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEFAULT_IGNORED_PACKAGES

    public static final String[] DEFAULT_IGNORED_PACKAGES

Constructor Detail

### ClassLoader

    public ClassLoader()

  Ignored packages are by default ( "java.", "sun.", "javax."), i.e. loaded by system class loader

### ClassLoader

    public ClassLoader(ClassLoader deferTo)

Parameters:
  `deferTo` - delegate class loader to use for ignored packages

### ClassLoader

    public ClassLoader(String[] ignored_packages)

Parameters:
  `ignored_packages` - classes contained in these packages will be loaded with the system class loader

### ClassLoader

    public ClassLoader(ClassLoader deferTo,
                       String[] ignored_packages)

Parameters:
  `ignored_packages` - classes contained in these packages will be loaded with the system class loader
  `deferTo` - delegate class loader to use for ignored packages

Method Detail

### loadClass

    protected Class loadClass(String class_name,
                              boolean resolve)
                       throws ClassNotFoundException

  Overrides:
    `loadClass` in class `ClassLoader`
  Throws:
    `ClassNotFoundException`

### modifyClass

    protected JavaClass modifyClass(JavaClass clazz)

  Override this method if you want to alter a class before it gets actually loaded. Does nothing by default.

### createClass

    protected JavaClass createClass(String class_name)

  Override this method to create you own classes on the fly. The name contains the special token $$BCEL$$. Everything before that token is consddered to be a package name. You can encode you own arguments into the subsequent string. You must regard however not to use any "illegal" characters, i.e., characters that may not appear in a Java class name too
  The default implementation interprets the string as a encoded compressed Java class, unpacks and decodes it with the Utility.decode() method, and parses the resulting byte array and returns the resulting JavaClass object.

  Parameters:
    `class_name` - compressed byte code with "$$BCEL$$" in it

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2006 Apache Software Foundation. All Rights Reserved.